input:not([type=checkbox]):not([type=radio]),
textarea,
select {
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
}

input, textarea {
    outline: none;
    &:focus:required:invalid { border-color: red }
    &:required:valid { border-color: green }
}

:active, :hover, :focus {
    outline: 0 !important;
    outline-offset: 0 !important;
}

option::selection {background: #ccc;}
option::-moz-selection {background: #ccc;}
option::-webkit-selection {background: #ccc; color:#fff;}

input[type="number"]::-webkit-outer-spin-button,
input[type="number"]::-webkit-inner-spin-button {
    display: none;
}

.field {
    width: 100%;
    display: block;
    font-weight: 400;
    position: relative;
    background: transparent;
    $input-selector: "input[type=text], input[type=email], input[type=date], input[type=password], input[type=number], textarea";

    #{$input-selector} {
        margin: 0;
        width: 100%;
        height: 44px;
        outline: none;
        color: $dark;
        box-shadow: none;
        font-weight: 600;
        font-size: rem(11);
        line-height: rem(16);
        padding: 13px 20px;
        background: #F1F0ED;
        display: inline-block;
        vertical-align: middle;
        border: 1px solid #F1F0ED;
        border-radius: 0;

        &::placeholder {
            color: transparent;
            display: none !important;
        }

        &::-ms-clear {
            display: none;
            width: 0;
            height: 0;
        }

        &:focus,
        &:active {
            outline: none;
            @include placeholder(transparent);
        }

        &:invalid {
            box-shadow: none;
            border-color: #F1F0ED;
        }

        &:-moz-submit-invalid {
            box-shadow: none;
            border-color: #F1F0ED;
        }

        &:-moz-ui-invalid {
            box-shadow:none;
            border-color: #F1F0ED;
        }
    }

    textarea {
        height: auto;
        resize: none;
    }

    &.error {


        #{$input-selector} {
            border-color: $purple;
        }
    }

    &__placeholder {
        top: 0;
        left: 0;
        color: #687173;
        padding: 14px 20px 14px 20px;
        font-weight: 500;
        font-size: rem(11);
        line-height: rem(16);
        position: absolute;
        text-overflow:ellipsis;

        &--required {
            &:after {
                content: '*';
                color: $purple;
                margin-left: rem(4);
            }
        }
    }

    &__icon {
        top: 26px;
        left: 20px;
        font-size: 0;
        line-height: 0;
        height: 16px;
        position: absolute;
        display: inline-block;
    }

    &--border {

        #{$input-selector} {
            background: $white;
            border-color: #b6b6b6;
        }
    }

    &--border-light {

        #{$input-selector} {
            background: $white;
            border-color: #F2F2F2;
        }
    }

    &--focus {

        .field__placeholder {
            opacity: 0;
            visibility: hidden;
            z-index: -1;
        }
    }

    &--icon {

        #{$input-selector} {
            height: 70px;
            padding: 26px 20px 26px 48px;
        }

        .field__placeholder {
            padding: 26px 20px 26px 48px;
        }
    }

    &--xs {

        #{$input-selector} {
            height: 40px;
            font-size: rem(12);
            padding: 11px 20px;
        }

        .field__placeholder {
            padding-top: rem(12);
        }
    }

    &--sm {

        #{$input-selector} {
            height: 48px;
            padding: 16px 20px;
        }

        .field__placeholder {
            padding-top: rem(16);
        }
    }

    @include media-breakpoint-up(md) {

        #{$input-selector} {
            height: 68px;
            font-size: rem(14);
            line-height: rem(18);
            padding: 24px 20px;
        }

        &__placeholder {
            padding: 26px 20px;
            font-size: rem(14);
            line-height: rem(18);
        }

        &--point {

            #{$input-selector} {
                padding-left: rem(38);
            }

            .field__placeholder {
                padding-left: rem(38);
            }

            &:before {
                top: 31px;
                left: 18px;
                z-index: 5;
                content: '';
                width: 6px;
                height: 6px;
                border-radius: 50%;
                position: absolute;
                border: 2px solid $purple;
                transition: .25s;
            }
        }

        &--focus {

            &:before {
                left: -3px;
                transition: .25s;
            }

            #{$input-selector} {
                padding-left: 18px;
                transition: .25s;
            }
        }

        &--icon {

            #{$input-selector} {
                padding-left: 48px !important;
            }
        }

        &--xs {

            #{$input-selector} {
                height: 46px;
                padding: 14px 20px;
            }

            .field__placeholder {
                padding-top: rem(14);
            }
        }

        &--sm {

            #{$input-selector} {
                height: 60px;
                padding: 20px 20px;
            }

            &:before {
                top: 28px;
            }

            .field__placeholder {
                padding-top: rem(21);
            }
        }

        &--md {

            #{$input-selector} {
                height: 56px;
                padding: 18px 20px;
            }

            &:before {
                top: 25px;
            }

            .field__placeholder {
                padding-top: rem(18);
            }
        }

        textarea {
            height: auto;
        }
    }

    @include media-breakpoint-up(xl) {

        #{$input-selector} {
            height: 70px;
            padding: 25px 20px 25px 20px;
        }

        &--point {


            #{$input-selector} {
                padding-left: rem(38);
            }

            &:before {
                top: 33px;
            }
        }

        &--focus {

            #{$input-selector} {
                padding-left: 18px;
                transition: .25s;
            }
        }

        &--xs {

            #{$input-selector} {
                height: 46px;
                padding: 14px 20px;
            }

            .field__placeholder {
                padding-top: rem(14);
            }
        }

        &--sm {

            #{$input-selector} {
                height: 60px;
            }

            &:before {
                top: 28px;
            }
        }

        &--md {

            #{$input-selector} {
                height: 56px;
                padding: 18px 20px;
            }

            &:before {
                top: 25px;
            }

            .field__placeholder {
                padding-top: rem(18);
            }
        }

        textarea {
            height: auto;
            resize: none;
        }
    }
}
